【64.52%】【codeforces 697D】Puzzles

来源:互联网 发布:python caffe log 编辑:程序博客网 时间:2024/04/29 10:05

time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Barney lives in country USC (United States of Charzeh). USC has n cities numbered from 1 through n and n - 1 roads between them. Cities and roads of USC form a rooted tree (Barney’s not sure why it is rooted). Root of the tree is the city number 1. Thus if one will start his journey from city 1, he can visit any city he wants by following roads.

Some girl has stolen Barney’s heart, and Barney wants to find her. He starts looking for in the root of the tree and (since he is Barney Stinson not a random guy), he uses a random DFS to search in the cities. A pseudo code of this algorithm is as follows:

let starting_time be an array of length n
current_time = 0
dfs(v):
current_time = current_time + 1
starting_time[v] = current_time
shuffle children[v] randomly (each permutation with equal possibility)
// children[v] is vector of children cities of city v
for u in children[v]:
dfs(u)
As told before, Barney will start his journey in the root of the tree (equivalent to call dfs(1)).

Now Barney needs to pack a backpack and so he wants to know more about his upcoming journey: for every city i, Barney wants to know the expected value of starting_time[i]. He’s a friend of Jon Snow and knows nothing, that’s why he asked for your help.

Input
The first line of input contains a single integer n (1 ≤ n ≤ 105) — the number of cities in USC.

The second line contains n - 1 integers p2, p3, …, pn (1 ≤ pi < i), where pi is the number of the parent city of city number i in the tree, meaning there is a road between cities numbered pi and i in USC.

Output
In the first and only line of output print n numbers, where i-th number is the expected value of starting_time[i].

Your answer for each city will be considered correct if its absolute or relative error does not exceed 10 - 6.

Examples
input
7
1 2 1 1 4 4
output
1.0 4.0 5.0 3.5 4.5 5.0 5.0
input
12
1 1 2 2 4 4 3 3 1 10 8
output
1.0 5.0 5.5 6.5 7.5 8.0 8.0 7.0 7.5 6.5 7.5 8.0

【题解】

题意:在树上进行dfs,从1节点开始dfs获取时间戳,每次dfs的时候搜的是任意一个儿子节点(每个节点搜到概率相同),求每个儿子的时间戳的期望;
这里写图片描述
首先1号节点的时间戳肯定是1.
ans[1] = 1;
然后我们考虑上图中1号节点的一个儿子节点3;
则有以下6种搜索的顺序
(它的子树就不写出来了)
1 2 3 4 ···①
1 2 4 3 ···②
1 3 2 4 ···③
1 3 4 2 ···④
1 4 2 3 ···⑤
1 4 3 2 ···⑥
(以下size[x]表示以x为根节点的子树的节点个数)
先让ans[3] = ans[1];
然后
③和④都是直接一步到达三号节点的,则增加量为2;
①则增加了size[2]+1,
②则增加了size[2]+size[4]+1;
⑤增加了size[4]+size[2]+1;
⑥增加了size[4]+1;
所以ans[3]+= (2+1+1+1+1 + 3*size[2] + 3*size[4])/6;
(除6可以这样理解,每种增加量的概率都是1/6)
再多观察一下。可以发现A(3,3)的所有排列中,所有1的直系儿子节点中除了3号节点外,其他节点在3号节点前面的概率都是1/2;
设3号节点的兄弟节点为a1,a2;
则我们最后ans[3]+= x
则x必然是 t1*size[a1] + t2*size[a2]+6 的形式
6可以理解吧?->这个常熟肯定是等于A(3,3)的
那么t1和t2的系数是多少呢?
“除了3号节点外,其他节点在3号节点前面的概率都是1/2”
根据这句话可以知道,那些系数t1,t2肯定都是相同的且为A(3,3)/2;
这样除下去就是1/2了。
所以归纳一下
ans[x] = ans[x的父亲节点] + (∑size[兄弟节点])/2 + 1

#include <cstdio>#include <vector>#include <iostream>using namespace std;const int MAXN = 2e5;int n, cnt[MAXN] = { 0 };double ans[MAXN] = { 0 };vector <int> a[MAXN];void input(int &r){    r = 0;    char t = getchar();    while (!isdigit(t)) t = getchar();    while (isdigit(t)) r = r * 10 + t - '0', t = getchar();}void dfs(int x){    cnt[x] = 1;    int len = a[x].size();    for (int i = 0; i <= len - 1; i++){        int y = a[x][i];        dfs(y);        cnt[x] += cnt[y];    }}void get_ans(int x){    int len = a[x].size();    for (int i = 0; i <= len - 1; i++){        int y = a[x][i];        ans[y] = ans[x] + 1.0 + ((cnt[x] - cnt[y] - 1)*1.0) / 2.0; //父亲节点的大小减去这y节点的大小再减去父亲节点本身,就是y的兄弟节点的大小了。        get_ans(y);    }}int main(){    //freopen("F:\\rush.txt", "r", stdin);    input(n);    for (int i = 2; i <= n; i++){        int x;        input(x);        a[x].push_back(i);    }    dfs(1);    ans[1] = 1.0;    get_ans(1);    for (int i = 1; i <= n; i++)         printf("%.1lf%c", ans[i],i==n?'\n':' ');    return 0;}
0 0